
Infrastructure - Story #6377

Review CNode initialization in ReplicationManager - it doesn't use local CN reference

2014-09-10 18:03 - Rob Nahf

Status: In Progress Start date: 2014-09-25

Priority: Normal Due date: 2014-09-25

Assignee: Rob Nahf % Done: 30%

Category: d1_replication Estimated time: 0.00 hour

Target version: CCI-2.4.0   

Story Points:    

Description

There is complicated fallback logic for performing certain CN API calls where the ReplicationManager CNode is supposed to be the

local CN baseurl, and if that fails, it falls back to using the ReplicationService (roundRobin) CN to perform the same call.  However,

ReplicationManager is already using the RR CN, unless the D1Client.CN_URL is different for different deployments.  But in that

case, ReplicationService would also use the same D1Client.CN_URL property.

Simplifying this would help encapsulate client interaction, and connection management.  Fallback CNode procurement uses

D1NodeFactory + a locally instantiated DefaultHttpMultipartRestClient for both ReplicationManager and ReplicationServices (a

recent temporary solution for v2).  This leads to two ConnectionManagers in the underlying HttpClient.

Since ReplicationManager is a complicated class, I would first look to encapsulate logic in the ReplicationService class.

Related issues:

Related to Infrastructure - Story #8639: Replication performance is too slow ... New 2018-07-04

History

#1 - 2014-09-25 17:25 - Dave Vieglais

- Due date set to 2014-09-25

- Start date set to 2014-09-25

- Target version set to Release Backlog

#2 - 2016-02-09 22:40 - Rob Nahf

- Assignee changed from Robert Waltz to Rob Nahf

- Target version changed from Release Backlog to CCI-2.2.0

work on this while working on the other Replication sotries for v2.2.  Some of the D1Client behavior has since been cleaned up, so reconfirm the

situation is still the same.

#3 - 2016-03-29 17:58 - Dave Vieglais

- Target version changed from CCI-2.2.0 to CCI-2.3.0

#4 - 2016-06-22 16:06 - Rob Nahf

- Status changed from New to In Progress

- % Done changed from 0 to 30

#5 - 2016-12-21 09:16 - Dave Vieglais

- Target version changed from CCI-2.3.0 to CCI-2.3.2

#6 - 2017-02-27 18:12 - Dave Vieglais

- Target version changed from CCI-2.3.2 to CCI-2.4.0
#7 - 2018-01-17 19:52 - Dave Vieglais

- Sprint set to CCI-2.3.8

#8 - 2018-07-04 11:19 - Dave Vieglais

- Related to Story #8639: Replication performance is too slow to service demand added
